﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace ClientServer.Migrations
{
    public partial class removeSolutionVersion4 : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_SolutionAssessment_SolutionVersions_SolutionVersionId",
                table: "SolutionAssessment");

            migrationBuilder.DropForeignKey(
                name: "FK_SolutionFiles_SolutionVersions_SolutionVersionId",
                table: "SolutionFiles");

            migrationBuilder.DropIndex(
                name: "IX_SolutionFiles_SolutionVersionId",
                table: "SolutionFiles");

            migrationBuilder.DropIndex(
                name: "IX_SolutionAssessment_SolutionVersionId",
                table: "SolutionAssessment");

            migrationBuilder.DropColumn(
                name: "MaxSolutionVersionsPerUser",
                table: "SystemSettings");

            migrationBuilder.DropColumn(
                name: "SolutionVersionId",
                table: "SolutionFiles");

            migrationBuilder.DropColumn(
                name: "SolutionVersionId",
                table: "SolutionAssessment");

            migrationBuilder.DropColumn(
                name: "MainSolutionVersionid",
                table: "Solutions");

            migrationBuilder.DropTable(
                name: "CustomTestWithSolutionAsTestResults");

            migrationBuilder.DropTable(
                name: "TestResults");

            migrationBuilder.DropTable(
                name: "SolutionVersions");
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "SolutionVersions",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MainFileId = table.Column<int>(nullable: true),
                    Note = table.Column<string>(nullable: true),
                    SolutionExerciseReleaseId = table.Column<int>(nullable: false),
                    SolutionPLangId = table.Column<int>(nullable: false),
                    SolutionUserId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SolutionVersions", x => x.Id);
                    table.ForeignKey(
                        name: "FK_SolutionVersions_SolutionFiles_MainFileId",
                        column: x => x.MainFileId,
                        principalTable: "SolutionFiles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                    table.ForeignKey(
                        name: "FK_SolutionVersions_Solutions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                        columns: x => new { x.SolutionUserId, x.SolutionExerciseReleaseId, x.SolutionPLangId },
                        principalTable: "Solutions",
                        principalColumns: new[] { "UserId", "ExerciseReleaseId", "PLangId" },
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomTestWithSolutionAsTestResults",
                columns: table => new
                {
                    CustomTestId = table.Column<int>(nullable: false),
                    SolutionVersionId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    HasCompiled = table.Column<bool>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Passed = table.Column<bool>(nullable: true),
                    ProgramExitCode = table.Column<int>(nullable: true),
                    Protocol = table.Column<string>(nullable: true),
                    TestResultCode = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomTestWithSolutionAsTestResults", x => new { x.CustomTestId, x.SolutionVersionId });
                    table.ForeignKey(
                        name: "FK_CustomTestWithSolutionAsTestResults_CustomTest_CustomTestId",
                        column: x => x.CustomTestId,
                        principalTable: "CustomTest",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomTestWithSolutionAsTestResults_SolutionVersions_SolutionVersionId",
                        column: x => x.SolutionVersionId,
                        principalTable: "SolutionVersions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "TestResults",
                columns: table => new
                {
                    TestId = table.Column<int>(nullable: false),
                    SolutionVersionId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    HasCompiled = table.Column<bool>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Passed = table.Column<bool>(nullable: true),
                    ProgramExitCode = table.Column<int>(nullable: true),
                    Protocol = table.Column<string>(nullable: true),
                    TestResultCode = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TestResults", x => new { x.TestId, x.SolutionVersionId });
                    table.ForeignKey(
                        name: "FK_TestResults_SolutionVersions_SolutionVersionId",
                        column: x => x.SolutionVersionId,
                        principalTable: "SolutionVersions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_TestResults_Tests_TestId",
                        column: x => x.TestId,
                        principalTable: "Tests",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.AddColumn<int>(
                name: "MaxSolutionVersionsPerUser",
                table: "SystemSettings",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "SolutionVersionId",
                table: "SolutionFiles",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "SolutionVersionId",
                table: "SolutionAssessment",
                nullable: true);

            migrationBuilder.AddColumn<int>(
                name: "MainSolutionVersionid",
                table: "Solutions",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.CreateIndex(
                name: "IX_SolutionFiles_SolutionVersionId",
                table: "SolutionFiles",
                column: "SolutionVersionId");

            migrationBuilder.CreateIndex(
                name: "IX_SolutionAssessment_SolutionVersionId",
                table: "SolutionAssessment",
                column: "SolutionVersionId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithSolutionAsTestResults_CustomTestId",
                table: "CustomTestWithSolutionAsTestResults",
                column: "CustomTestId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithSolutionAsTestResults_SolutionVersionId",
                table: "CustomTestWithSolutionAsTestResults",
                column: "SolutionVersionId");

            migrationBuilder.CreateIndex(
                name: "IX_SolutionVersions_MainFileId",
                table: "SolutionVersions",
                column: "MainFileId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_SolutionVersions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                table: "SolutionVersions",
                columns: new[] { "SolutionUserId", "SolutionExerciseReleaseId", "SolutionPLangId" });

            migrationBuilder.CreateIndex(
                name: "IX_TestResults_SolutionVersionId",
                table: "TestResults",
                column: "SolutionVersionId");

            migrationBuilder.CreateIndex(
                name: "IX_TestResults_TestId",
                table: "TestResults",
                column: "TestId");

            migrationBuilder.AddForeignKey(
                name: "FK_SolutionAssessment_SolutionVersions_SolutionVersionId",
                table: "SolutionAssessment",
                column: "SolutionVersionId",
                principalTable: "SolutionVersions",
                principalColumn: "Id",
                onDelete: ReferentialAction.SetNull);

            migrationBuilder.AddForeignKey(
                name: "FK_SolutionFiles_SolutionVersions_SolutionVersionId",
                table: "SolutionFiles",
                column: "SolutionVersionId",
                principalTable: "SolutionVersions",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
