﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace ClientServer.Migrations
{
    public partial class SomeDeleteActionsChanged1 : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_Templates_PLangs_PLangId",
                table: "Templates");

            migrationBuilder.DropForeignKey(
                name: "FK_ExerciseReleases_PLangs_PLangId",
                table: "ExerciseReleases");

            migrationBuilder.DropForeignKey(
                name: "FK_ExerciseReleaseWithUserAsParticipations_PLangs_LastEditedPLangId",
                table: "ExerciseReleaseWithUserAsParticipations");

            migrationBuilder.DropForeignKey(
                name: "FK_Solutions_PLangs_PLangId",
                table: "Solutions");

            migrationBuilder.DropForeignKey(
                name: "FK_SystemSettings_GroupRoles_DefaultGroupCreatorGroupRoleId",
                table: "SystemSettings");

            migrationBuilder.DropForeignKey(
                name: "FK_SystemSettings_GroupRoles_DefaultGroupRoleId",
                table: "SystemSettings");

            migrationBuilder.DropForeignKey(
                name: "FK_SystemSettings_UserGroups_DefaultUserGroupId",
                table: "SystemSettings");

            migrationBuilder.DropForeignKey(
                name: "FK_UserWithUserGroups_GroupRoles_GroupRoleId",
                table: "UserWithUserGroups");

            migrationBuilder.AddForeignKey(
                name: "FK_Templates_PLangs_PLangId",
                table: "Templates",
                column: "PLangId",
                principalTable: "PLangs",
                principalColumn: "Id",
                onDelete: ReferentialAction.Restrict);

            migrationBuilder.AddForeignKey(
                name: "FK_ExerciseReleases_PLangs_PLangId",
                table: "ExerciseReleases",
                column: "PLangId",
                principalTable: "PLangs",
                principalColumn: "Id",
                onDelete: ReferentialAction.Restrict);

            migrationBuilder.AddForeignKey(
                name: "FK_ExerciseReleaseWithUserAsParticipations_PLangs_LastEditedPLangId",
                table: "ExerciseReleaseWithUserAsParticipations",
                column: "LastEditedPLangId",
                principalTable: "PLangs",
                principalColumn: "Id",
                onDelete: ReferentialAction.Restrict);

            migrationBuilder.AddForeignKey(
                name: "FK_Solutions_PLangs_PLangId",
                table: "Solutions",
                column: "PLangId",
                principalTable: "PLangs",
                principalColumn: "Id",
                onDelete: ReferentialAction.Restrict);

            migrationBuilder.AddForeignKey(
                name: "FK_SystemSettings_GroupRoles_DefaultGroupCreatorGroupRoleId",
                table: "SystemSettings",
                column: "DefaultGroupCreatorGroupRoleId",
                principalTable: "GroupRoles",
                principalColumn: "Id",
                onDelete: ReferentialAction.Restrict);

            migrationBuilder.AddForeignKey(
                name: "FK_SystemSettings_GroupRoles_DefaultGroupRoleId",
                table: "SystemSettings",
                column: "DefaultGroupRoleId",
                principalTable: "GroupRoles",
                principalColumn: "Id",
                onDelete: ReferentialAction.Restrict);

            migrationBuilder.AddForeignKey(
                name: "FK_SystemSettings_UserGroups_DefaultUserGroupId",
                table: "SystemSettings",
                column: "DefaultUserGroupId",
                principalTable: "UserGroups",
                principalColumn: "Id",
                onDelete: ReferentialAction.Restrict);

            migrationBuilder.AddForeignKey(
                name: "FK_UserWithUserGroups_GroupRoles_GroupRoleId",
                table: "UserWithUserGroups",
                column: "GroupRoleId",
                principalTable: "GroupRoles",
                principalColumn: "Id",
                onDelete: ReferentialAction.Restrict);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_Templates_PLangs_PLangId",
                table: "Templates");

            migrationBuilder.DropForeignKey(
                name: "FK_ExerciseReleases_PLangs_PLangId",
                table: "ExerciseReleases");

            migrationBuilder.DropForeignKey(
                name: "FK_ExerciseReleaseWithUserAsParticipations_PLangs_LastEditedPLangId",
                table: "ExerciseReleaseWithUserAsParticipations");

            migrationBuilder.DropForeignKey(
                name: "FK_Solutions_PLangs_PLangId",
                table: "Solutions");

            migrationBuilder.DropForeignKey(
                name: "FK_SystemSettings_GroupRoles_DefaultGroupCreatorGroupRoleId",
                table: "SystemSettings");

            migrationBuilder.DropForeignKey(
                name: "FK_SystemSettings_GroupRoles_DefaultGroupRoleId",
                table: "SystemSettings");

            migrationBuilder.DropForeignKey(
                name: "FK_SystemSettings_UserGroups_DefaultUserGroupId",
                table: "SystemSettings");

            migrationBuilder.DropForeignKey(
                name: "FK_UserWithUserGroups_GroupRoles_GroupRoleId",
                table: "UserWithUserGroups");

            migrationBuilder.AddForeignKey(
                name: "FK_Templates_PLangs_PLangId",
                table: "Templates",
                column: "PLangId",
                principalTable: "PLangs",
                principalColumn: "Id",
                onDelete: ReferentialAction.SetNull);

            migrationBuilder.AddForeignKey(
                name: "FK_ExerciseReleases_PLangs_PLangId",
                table: "ExerciseReleases",
                column: "PLangId",
                principalTable: "PLangs",
                principalColumn: "Id",
                onDelete: ReferentialAction.SetNull);

            migrationBuilder.AddForeignKey(
                name: "FK_ExerciseReleaseWithUserAsParticipations_PLangs_LastEditedPLangId",
                table: "ExerciseReleaseWithUserAsParticipations",
                column: "LastEditedPLangId",
                principalTable: "PLangs",
                principalColumn: "Id",
                onDelete: ReferentialAction.SetNull);

            migrationBuilder.AddForeignKey(
                name: "FK_Solutions_PLangs_PLangId",
                table: "Solutions",
                column: "PLangId",
                principalTable: "PLangs",
                principalColumn: "Id",
                onDelete: ReferentialAction.SetNull);

            migrationBuilder.AddForeignKey(
                name: "FK_SystemSettings_GroupRoles_DefaultGroupCreatorGroupRoleId",
                table: "SystemSettings",
                column: "DefaultGroupCreatorGroupRoleId",
                principalTable: "GroupRoles",
                principalColumn: "Id",
                onDelete: ReferentialAction.SetNull);

            migrationBuilder.AddForeignKey(
                name: "FK_SystemSettings_GroupRoles_DefaultGroupRoleId",
                table: "SystemSettings",
                column: "DefaultGroupRoleId",
                principalTable: "GroupRoles",
                principalColumn: "Id",
                onDelete: ReferentialAction.SetNull);

            migrationBuilder.AddForeignKey(
                name: "FK_SystemSettings_UserGroups_DefaultUserGroupId",
                table: "SystemSettings",
                column: "DefaultUserGroupId",
                principalTable: "UserGroups",
                principalColumn: "Id",
                onDelete: ReferentialAction.SetNull);

            migrationBuilder.AddForeignKey(
                name: "FK_UserWithUserGroups_GroupRoles_GroupRoleId",
                table: "UserWithUserGroups",
                column: "GroupRoleId",
                principalTable: "GroupRoles",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
